	.include "c:\dev\gb\lib\global.s"


__SIO_DEST = 0xDF00


_SioStart::


;disable interrupts
	xor		a, a
	ld		(.IE), a
	di


;copy
	ld		hl,	#__SIO_SRC
	ld		de,	#__SIO_DEST
	ld		bc,	#__SIO_END - __SIO_SRC
1$:
	ld		a, (hl+)
	ld		(de), a
	inc		de
	dec		bc
	ld		a, b
	or		a, c
	jr		nz,	1$

	ld		a, #'*

	jp		__SIO_DEST







__SIO_SRC::
1$:
	;ld	b, a
;2$:					;wait for vram
	;ldh	a, (.STAT)
	;and	a, #0x02
	;jr	nz,	2$
	;ld	a, b

	;ld		(0x9800+32*8+9), a
	;ld		(0x9C00+32*8+9), a
	;call	SendByte + __SIO_DEST -	__SIO_SRC
	call	.SioCmd	+ __SIO_DEST - __SIO_SRC
	jr		1$



;enable	interrupts
EI:
	ei
	ret

;disable interrupts
DI:
	di
	ret



;get/execute command
.SioCmd:
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	cp		a, #'r
	jr		z, ReadBlock	;read block
	cp		a, #'w
	jr		z, WriteBlock	;write block
	cp		a, #'j
	jr		z, Jump			;jump
	cp		a, #'c
	jr		z, Call			;call
	cp		a, #'s
	jr		z, Stop			;stop
	cp		a, #'1
	jr		z, Single		;single	speed
	cp		a, #'2
	jr		z, Double		;double	speed
	cp		a, #'e
	jr		z, EI			;enable	interrupts
	cp		a, #'d
	jr		z, DI			;disable interrupts
	ret


;send byte
SendByte:
	ldh		(.SB), a
;receive byte
ReadByte:
	ld		a, #0x80
	ldh		(.SC), a
1$:
	ldh		a, (.SC)
	and		a, #0x80
	jr		nz,	1$
	ldh		a, (.SB)
	ret




;read block
ReadBlock:
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	ld		h, a
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	ld		l, a
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	ld		b, a
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	ld		c, a
1$:
	ld		a, (hl+)
	call	SendByte + __SIO_DEST -	__SIO_SRC
	dec		bc
	ld		a, b
	or		a, c
	jr		nz,	1$
	ret


;write block
WriteBlock:
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	ld		h, a
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	ld		l, a
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	ld		b, a
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	ld		c, a

1$:
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	ld		(hl+), a
	dec		bc
	ld		a, b
	or		a, c
	jr		nz,	1$
	ret


;jump
Jump:
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	ld		h, a
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	ld		l, a
JP:
	jp		(hl)


;call
Call:
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	ld		h, a
	call	ReadByte + __SIO_DEST -	__SIO_SRC
	ld		l, a
	call	JP + __SIO_DEST -	__SIO_SRC
	ret



;stop
Stop:
	ldh		a, (.LCDC)
	and		a, #0x7F
	ldh		(.LCDC), a
	stop
	nop
	or		a, #0x80
	ldh		(.LCDC), a
	ret

;single	speed
Single:
	ldh		a, (.KEY1)
	and		a, #0x80	;in	double speed mode?
	ret		z			;already in	single speed
	jr		SetSpeed


;double	speed
Double:
	ldh		a, (.KEY1)
	and		a, #0x80	;in	double speed mode?
	ret		nz			;yes
	jr		SetSpeed






;change	speed
SetSpeed:
	ld		a, #0x30
	ldh		(.P1), a
	ld		a, #0x01
	ldh		(.KEY1), a
	stop
	nop
	ret




__SIO_END::
